﻿using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using Wp7nl.Behaviors;

namespace MirrorBehaviorDemo.ViewModel
{
  public class DemoViewModel : ViewModelBase
  {
    private bool isMirrored = false;
    public bool IsMirrored
    {
      get { return isMirrored; }
      set
      {
        if (isMirrored != value)
        {
          isMirrored = value;
          RaisePropertyChanged(() => IsMirrored);
        }
      }
    }

    public ICommand MirrorCommand
    {
      get
      {
        return new RelayCommand(
            () =>
            {
              IsMirrored = !IsMirrored;
            });
      }
    }

    private bool horizontalChecked;
    public bool HorizontalChecked
    {
      get { return horizontalChecked; }
      set
      {
        if (horizontalChecked != value)
        {
          horizontalChecked = value;
          RaisePropertyChanged(() => HorizontalChecked);
          RaisePropertyChanged(() => MirrorDirection);
        }
      }
    }

    private bool verticalChecked = true;
    public bool VerticalChecked
    {
      get { return verticalChecked; }
      set
      {
        if (verticalChecked != value)
        {
          verticalChecked = value;
          RaisePropertyChanged(() => VerticalChecked);
          RaisePropertyChanged(() => MirrorDirection);
        }
      }
    }

    public Direction MirrorDirection
    {
      get
      {
        if (HorizontalChecked && VerticalChecked)
        {
          return Direction.Both;
        }

        if (VerticalChecked)
        {
          return Direction.Vertical;
        }

        return Direction.Horizontal;
      }
    }
  }
}
