﻿using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace Wp7nl.Utilities
{
  /// <summary>
  /// Extension methods to add animations to a storyboard
  /// </summary>
  public static class StoryboardExtensions3
  {
    public static void AddScalingAnimation(this Storyboard storyboard,
                                           FrameworkElement fe, double fromX, double toX,
                                           double fromY, double toY, Duration duration)
    {
      storyboard.AddScalingAnimation(fe, fromX, toX, fromY, toY, duration, null);
    }

    public static void AddScalingAnimation(this Storyboard storyboard,
                                           FrameworkElement fe, double fromX, double toX,
                                           double fromY, double toY, Duration duration,
                                           IEasingFunction easingFunction)
    {
      storyboard.AddAnimation(fe.RenderTransform,
                   storyboard.CreateDoubleAnimation(duration, fromX, toX, easingFunction),
                      CompositeTransform.ScaleXProperty);
      storyboard.AddAnimation(fe.RenderTransform,
                  storyboard.CreateDoubleAnimation(duration, fromY, toY, easingFunction),
                     CompositeTransform.ScaleYProperty);
    }

    public static void AddOpacityAnimation(this Storyboard storyboard,
                                           UIElement fe, double from, double to,
                                           Duration duration)
    {
      AddOpacityAnimation(storyboard, fe, from, to, duration, null);
    }

    public static void AddOpacityAnimation(this Storyboard storyboard,
              UIElement fe, double from, double to, Duration duration,
              IEasingFunction easingFunction)
    {
      storyboard.AddAnimation(fe,
             storyboard.CreateDoubleAnimation(duration, from, to, easingFunction),
             UIElement.OpacityProperty);
    }
  }
}
